//+------------------------------------------------------------------+
//|                                     Fractals - adjustable period |
//+------------------------------------------------------------------+
#property link      "www.forex-station.com"
#property copyright "www.forex-station.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames       TimeFrame       = tf_cu;             // Time frame
extern int                TimeFrameCustom = 0;                 // Custom time frame to use (if custom time frame used)
extern int                FractalPeriod   = 25;                // Fractal period 5 = std mt4 fractal
extern ENUM_APPLIED_PRICE PriceHigh       = PRICE_HIGH;        // Upper fractal price
extern ENUM_APPLIED_PRICE PriceLow        = PRICE_LOW;         // Lower fractal price
input color               ColorUp         = clrLimeGreen;      // Up color 
input color               ColorDn         = clrRed;            // Down color
input int                 HistoWidth      = 3;                 // Histogram bars width
extern bool               alertsOn        = true;              // Turn alerts on?
extern bool               alertsOnCurrent = false;             // Alerts on still opened bar?
extern bool               alertsMessage   = true;              // Alerts should show popup message?
extern bool               alertsSound     = false;             // Alerts should play a sound?
extern bool               alertsEmail     = false;             // Alerts should send email?
extern bool               alertsNotify    = false;             // Alerts should send notification?
 

double Up[],Dn[],upper[],lower[],trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int OnInit()
{ 
    IndicatorBuffers(9);
    SetIndexBuffer(0,Up,   INDICATOR_DATA);  SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,HistoWidth,ColorUp);
    SetIndexBuffer(1,Dn,   INDICATOR_DATA);  SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,HistoWidth,ColorDn);
    SetIndexBuffer(2,upper,INDICATOR_CALCULATIONS); 
    SetIndexBuffer(3,lower,INDICATOR_CALCULATIONS);    
    SetIndexBuffer(4,trend,INDICATOR_CALCULATIONS); 
    
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; 
         if (TimeFrameCustom==0) TimeFrameCustom = fmax(TimeFrameCustom,_Period);
         if (TimeFrame!=tf_cus)
               TimeFrame = fmax(TimeFrame,_Period);
         else  TimeFrame = (enTimeFrames)TimeFrameCustom;
      
return(INIT_SUCCEEDED);
}
void OnDeinit(const int reason) { }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
    int i,k,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = fmin(Bars-counted_bars,Bars-1);
            if (returnBars) { Up[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
     int half = FractalPeriod/2;    
     for(i=limit; i>=0; i--) 
     {
         bool   found     = true;
         double compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i);
         for (k=1; k<=half && (i+k)<Bars; k++)
            {
               if ((i+k)<Bars && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i+k)> compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i-k)>=compareTo) { found=false; break; }
            }
         if (found) upper[i] = High[i];
         else       upper[i] = upper[i+1];

         //
         //
         //
         //
         //
      
         found     = true;
         compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceLow,i);
         for (k=1; k<=half&& (i+k)<Bars; k++)
            {
               if ((i+k)<Bars && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i+k)< compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i-k)<=compareTo) { found=false; break; }
            }
         if (found) lower[i] = Low[i];
         else       lower[i] = lower[i+1];
         
         
             trend[i]  = (i<Bars-1) ? (Close[i]>upper[i]) ? 1 : (Close[i]<lower[i]) ? -1 : trend[i+1] : 0;
             Up[i] = (trend[i] ==  1) ? 1 : EMPTY_VALUE;
             Dn[i] = (trend[i] == -1) ? 1 : EMPTY_VALUE;         
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"breaking up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"breaking down");
      }         
   }
   return(0);
   }
   
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Up[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,FractalPeriod,PriceHigh,PriceLow,ColorUp,ColorDn,HistoWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,y);
         Dn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,FractalPeriod,PriceHigh,PriceLow,ColorUp,ColorDn,HistoWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,1,y);
   }
return(0);
}
     
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Fractal Channel ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Fractal Channel "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}